// @flow
import axios from 'axios';

const convert = require('xml-js');
const xml2jsonOptions = {ignoreDeclaration: true, compact: true, spaces: 4};

class Index {
    constructor(domain: String, database: String, username: String, password: String) {
        this.domain = domain || "quickbase.com";
        this.database = database || "database";
        this.username = username || "jeffy";
        this.password = password || "abc123";
    }

    async auth(): String {
        const url = "https://".concat(this.domain,
            "/db/main?a=API_Authenticate&username=", this.username,
            "&password=", this.password,
            "&hours=24");
        const response = await axios.get(url);
        const responseJson = JSON.parse(convert.xml2json(response.data, xml2jsonOptions)).qdbapi;

        return {
            errcode: responseJson.errcode._text,
            errtext: responseJson.errtext._text,
            data: responseJson.ticket ? responseJson.ticket._text : null
        };
    }

    async getSchema(ticket: String): String {
        const url = "https://".concat(this.domain,
            "/db/", this.database,
            "?a=API_GetSchema",
            "&ticket=", ticket);

        return "";
        //https://target_domain/db/target_dbid?a=API_GetSchema&ticket=auth_ticket&apptoken=app_token&udata=mydata
    }

    async query(sql="select * from user"): Object {
        var parse = require('node-sqlparser').parse;
        var stringify = require('node-sqlparser').stringify;
        var astObj = parse(sql);

        return astObj;
    }

    async select(ticket: String, table: String, query: String): Object {
        const url = "https://".concat(this.domain,
            "/db/", table,
            "?a=API_DoQuery&includeRids=1&ticket=", ticket,
            "&query=", query);

        //https://davidbarnes-861.quickbase.com/db/bpan65pb7?a=API_DoQuery&includeRids=1&ticket=9_bparsijzy_b4ayws_mps6_a_-b_bxchxt9b44msp8p9p64jb2uva99c9yfhqddfhvmgd53cutecu5ybk_bxf6q5v

        const response = await axios.get(url);
        const responseJson = JSON.parse(convert.xml2json(response.data, xml2jsonOptions)).qdbapi;



        return responseJson;
    }

}

export default Index;